﻿// vim: set filetype=c :
//
// delegates.h:
//
// Authors:
//   Rolf Bjarne Kvinge <rolf@xamarin.com>
//
// Copyright 2018 Microsoft Inc.
//

/* Functions calling into ObjCRuntime.Runtime */


#ifndef __RUNTIME_GENERATED_H__
#define __RUNTIME_GENERATED_H__

#include "xamarin.h"

#ifdef __cplusplus
extern "C" {
#endif

void
xamarin_gc_collect (GCHandle *exception_gchandle = NULL);

void
xamarin_throw_ns_exception (NSException * exc);

void
xamarin_rethrow_managed_exception (GCHandle original_exception_gchandle, GCHandle *exception_gchandle = NULL);

GCHandle
xamarin_create_ns_exception (NSException * exc, GCHandle *exception_gchandle = NULL);

NSException *
xamarin_unwrap_ns_exception (GCHandle exc_handle, GCHandle *exception_gchandle = NULL);

MonoObject *
xamarin_create_block_proxy (GCHandle method, void * block, GCHandle *exception_gchandle = NULL);

id
xamarin_create_delegate_proxy (MonoReflectionMethod * method, MonoObject * block, const char * signature, unsigned int token_ref, GCHandle *exception_gchandle = NULL);

MonoObject *
xamarin_get_class (Class ptr, GCHandle *exception_gchandle = NULL);

MonoObject *
xamarin_get_selector (SEL ptr, GCHandle *exception_gchandle = NULL);

bool
xamarin_has_nsobject (id obj, GCHandle *exception_gchandle = NULL);

id
xamarin_get_handle_for_inativeobject (MonoObject * obj_handle, GCHandle *exception_gchandle = NULL);

void
xamarin_unregister_nsobject (id native_obj, GCHandle managed_obj, GCHandle *exception_gchandle = NULL);

MonoObject *
xamarin_try_get_or_construct_nsobject (id obj, GCHandle *exception_gchandle = NULL);

MonoObject *
xamarin_get_inative_object_dynamic (id obj, bool owns, MonoReflectionType * type, GCHandle *exception_gchandle = NULL);

GCHandle
xamarin_get_method_from_token (unsigned int token_ref, GCHandle *exception_gchandle = NULL);

GCHandle
xamarin_get_generic_method_from_token (MonoObject * obj_handle, unsigned int token_ref, GCHandle *exception_gchandle = NULL);

MonoObject *
xamarin_get_inative_object_static (id obj, bool owns, unsigned int iface_token_ref, unsigned int implementation_token_ref, GCHandle *exception_gchandle = NULL);

MonoObject *
xamarin_get_nsobject_with_type (id obj, MonoReflectionType * type, int32_t * created, GCHandle *exception_gchandle = NULL);

void
xamarin_dispose (MonoObject* mobj, GCHandle *exception_gchandle = NULL);

GCHandle
xamarin_create_product_exception_for_error (int code, GCHandle inner_exception_gchandle, const char * message, GCHandle *exception_gchandle = NULL);

char *
xamarin_reflection_type_get_full_name (MonoReflectionType * type, GCHandle *exception_gchandle = NULL);

char *
xamarin_lookup_managed_type_name (Class klass, GCHandle *exception_gchandle = NULL);

enum MarshalManagedExceptionMode
xamarin_on_marshal_managed_exception (GCHandle exception, GCHandle *exception_gchandle = NULL);

enum MarshalObjectiveCExceptionMode
xamarin_on_marshal_objectivec_exception (id exception, bool throwManagedAsDefault, GCHandle *exception_gchandle = NULL);

GCHandle
xamarin_create_runtime_exception (int32_t code, const char * message, GCHandle *exception_gchandle = NULL);

GCHandle
xamarin_create_nsobject (MonoReflectionType * type_gchandle, id native_obj, enum NSObjectFlags flags, GCHandle *exception_gchandle = NULL);

#if defined (CORECLR_RUNTIME)
MonoAssembly *
xamarin_find_assembly (const char * assembly_name, GCHandle *exception_gchandle = NULL);
#endif // CORECLR_RUNTIME

#if defined (CORECLR_RUNTIME)
GCHandle
xamarin_bridge_create_gchandle (GCHandle gchandle, enum XamarinGCHandleType type, GCHandle *exception_gchandle = NULL);
#endif // CORECLR_RUNTIME

#if defined (CORECLR_RUNTIME)
void
xamarin_bridge_free_gchandle (GCHandle gchandle, GCHandle *exception_gchandle = NULL);
#endif // CORECLR_RUNTIME


#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* __RUNTIME_GENERATED_H__ */
